#include "fivewin.ch"

REQUEST DBFCDX

STATIC pDirectorio
STATIC pExtension
STATIC pNuevo
STATIC pRespaldo
STATIC pHistory
STATIC pOpenLast
STATIC pAutoSave
STATIC nAutoSave
STATIC pTips
STATIC pLenguage
STATIC pTabs

function main(cFileName)
   pDirectorio  = TraeIni("PRINCIPAL", "Directorio", ".\")
   pExtension   = TraeIni("PRINCIPAL", "Extension" , "frx")
   pNuevo       = TraeIni("PRINCIPAL", "Nuevo"     , "N" )
   pRespaldo    = TraeIni("PRINCIPAL", "Respaldo"  , "bak")
   pHistory     = TraeIni("PRINCIPAL", "History"   , 2)
   pOpenLast    = TraeIni("PRINCIPAL", "OpenLast"  , "S")
   pAutosave    = TraeIni("PRINCIPAL", "Autosave"  , 120)
   pTips        = TraeIni("PRINCIPAL", "Tips"      , "S")
   pTabs        = TraeIni("PRINCIPAL", "Tabs"      , 4)
   pLenguage    = TraeIni("PRINCIPAL", "Linguagem" , "Portugues")

   rddSetDefault( "DBFCDX" )

   use purc1
   index on purc tag purc to purc1
   use
   use purc2
   index on purc tag purc to purc2
   use
   use supplier
   index on supp tag supp to supplier
   use

   IF pOpenLast = "S" .AND. ;
      EMPTY(cFileName) .AND. !EMPTY( TraeIni("PRINCIPAL","LastFile","") )
      cFileName = TraeIni("PRINCIPAL","LastFile","")
   ENDIF

   DEFINE WINDOW oWnd FROM 1, 5 TO 20, 75 MENU BuildMenu() TITLE 'Report Test' COLOR CLR_BLACK,CLR_GRAY
   ACTIVATE WINDOW oWnd MAXIMIZED
   return nil

FUNCTION BuildMenu()
   local oMenu
   MENU oMenu
      MENUITEM "Arquivos"
      MENU
         MENUITEM "Novo" + Chr( 9 ) + "Ctrl+N"  ACTION PrgNew()
         MENUITEM "Abrir" + Chr( 9 ) + "Ctrl+A" ACTION PrgOpen()
         MENUITEM "Salvar" + Chr( 9 ) + "Ctrl+G" ACTION PrgSave() // WHEN oEdit != nil
         MENUITEM "Salvar como..." ACTION PrgSaveAs() // WHEN oEdit != nil
         SEPARATOR
         MENUITEM 'Configuraao' ACTION fRep('Set')
         SEPARATOR
         MENUITEM "Imprimir" ACTION fRep('Print') // WHEN oEdit != nil
         SEPARATOR
         MENUITEM "Sair" ACTION oWnd:End()
         //MRU oMruFiles INI "hedit.ini" SECTION "MRU-Files" ;
         //    MESSAGE tMAbrirMru ACTION PrgOpen( cMruItem )
      ENDMENU
   ENDMENU
   return oMenu

FUNCTION PrgNew()
   LOCAL cFileName := pDirectorio + cGetNewFileName( pNuevo , pExtension )
   fRep( 'New', cFileName )
   return .t.

FUNCTION cGetNewFileName( cName, cExt )
   LOCAL cTemp := cName + "1" + "." + cExt
   LOCAL nId   := 1
   do while File( cTemp )
      cTemp = cName + StrZero( ++nId, If( nId < 10, 1, 2 ) ) + ;
              "." + cExt
   enddo
   return cTemp

FUNCTION PrgOpen()
   LOCAL cFileName := cGetFile( "Format Report XBase (*.frx) |*.frx|", "Selecione o arquivo",,".\",, .T. )
   fRep( 'Edit', cFileName )
   return .t.

FUNCTION PrgSave()
   return .t.

FUNCTION PrgSaveAs()
   return .t.

FUNCTION fRep( cMode, cFile )
   default cFile := 'po.frx'
   USE report SHARED
   if eof()
      append blank
   endif
   rlock()
   REPLACE mode   with cMode
   REPLACE path   with ''
   REPLACE report with cFile // 'po.frx'
   unlock
   waitrun( 'vfp.exe', 3 )
   return .t.

FUNCTION TraeIni(cSeccion,cEntry,gDefault)
   LOCAL oIni,gGet
   DEFAULT gDefault := nil
   INI oIni FILE "hEdit"
   IF gDefault == nil
      GET gGet SECTION cSeccion ENTRY cEntry OF oIni
   ELSE
      GET gGet SECTION cSeccion ENTRY cEntry OF oIni DEFAULT gDefault
   ENDIF
   ENDINI
   RETURN gGet

FUNCTION DejaIni(cSeccion,cEntry,gDato)
   LOCAL oIni
   INI oIni FILE "hEdit"
   SET SECTION cSeccion ENTRY cEntry TO gDato OF oIni
   ENDINI
   RETURN nil

DLL32 Function GetFullPathName( lpszFile AS LPSTR, cchPath AS DWORD,;
               lpszPath AS LPSTR, @nFilePos AS PTR ) AS DWORD ;
               PASCAL FROM "GetFullPathNameA" LIB "kernel32.dll"
DLL32 Function apiFindFst(lpFilename AS LPSTR, @cWin32DataInfo AS LPSTR) AS LONG PASCAL FROM "FindFirstFileA" LIB "KERNEL32.DLL"
DLL32 Function apiFindNxt(nHandle AS LONG, @cWin32DataInfo AS LPSTR) AS BOOL PASCAL FROM "FindNextFileA" LIB "KERNEL32.DLL"
DLL32 Function apiFindCls(nHandle AS LONG) AS BOOL PASCAL FROM "FindClose" LIB "KERNEL32.DLL"
DLL32 Function apiFT2DT(@lpFT AS LPSTR, @lpDATE AS LPSTR, @lpTIME AS LPSTR) AS BOOL PASCAL FROM "FileTimeToDosDateTime" LIB "KERNEL32.DLL"
DLL32 Function apiFT2LT(@lpFT AS LPSTR, @lpLT AS LPSTR) AS BOOL PASCAL FROM "FileTimeToLocalFileTime" LIB "KERNEL32.DLL"
DLL32 STATIC FUNCTION COPYFILE( cOldName AS LPSTR, cNewName AS LPSTR ) AS BOOL PASCAL FROM "CopyFileA" LIB "kernel32.dll"
